Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Menu

    java.lang.Object
      |
      +--java.awt.MenuComponent
            |
            +--java.awt.MenuItem
                  |
                  +--java.awt.Menu

All Implemented Interfaces:
  Accessible, MenuContainer, Serializable

Direct Known Subclasses:
  PopupMenu

public class Menu
extends MenuItem
implements MenuContainer, Accessible

A `Menu` object is a pull-down menu component that is deployed from a menu bar.

A menu can optionally be a tear-off menu. A tear-off menu can be opened and dragged away from its parent menu bar or menu. It remains on the screen after the mouse button has been released. The mechanism for tearing off a menu is platform dependent, since the look and feel of the tear-off menu is determined by its peer. On platforms that do not support tear-off menus, the tear-off property is ignored.

Each item in a menu must belong to the `MenuItem` class. It can be an instance of `MenuItem`, a submenu (an instance of `Menu`), or a check box (an instance of `CheckboxMenuItem`).

Since:
  JDK1.0
See Also:
  `MenuItem`, `CheckboxMenuItem`, Serialized Form

Inner Class Summary
`protected class` | `Menu.AccessibleAWTMenu` Inner class of Menu used to provide default support for accessibility.

Inner classes inherited from class java.awt.MenuItem
`MenuItem.AccessibleAWTMenuItem`

Inner classes inherited from class java.awt.MenuComponent
`MenuComponent.AccessibleAWTMenuComponent`

Constructor Summary
`Menu()` Constructs a new menu with an empty label.
`Menu(String label)` Constructs a new menu with the specified label.
`Menu(String label, boolean tearOff)` Constructs a new menu with the specified label, indicating whether the menu can be torn off.

Method Summary
`MenuItem` | `add(MenuItem mi)` Adds the specified menu item to this menu.
`void` | `add(String label)` Adds an item with the specified label to this menu.
`void` | `addNotify()` Creates the menu's peer.
`void` | `addSeparator()` Adds a separator line, or a hypen, to the menu at the current position.
`int` | `countItems()` Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.
`AccessibleContext` | `getAccessibleContext()` Gets the AccessibleContext associated with this Menu.
`MenuItem` | `getItem(int index)` Gets the item located at the specified index of this menu.
`int` | `getItemCount()` Get the number of items in this menu.
`void` | `insert(MenuItem menuitem, int index)` Inserts a menu item into this menu at the specified position.
`void` | `insert(String label, int index)` Inserts a menu item with the specified label into this menu at the specified position.
`void` | `insertSeparator(int index)` Inserts a separator at the specified position.
`boolean` | `isTearOff()` Indicates whether this menu is a tear-off menu.
`String` | `paramString()` Gets the parameter string representing the state of this menu.
`void` | `remove(int index)` Removes the menu item at the specified index from this menu.
`void` | `remove(MenuComponent item)` Removes the specified menu item from this menu.
`void` | `removeAll()` Removes all items from this menu.
`void` | `removeNotify()` Removes the menu's peer.

Methods inherited from class java.awt.MenuItem
`addActionListener, deleteShortcut, disable, disableEvents, enable, enable, enableEvents, getActionCommand, getLabel, getListeners, getShortcut, isEnabled, processActionEvent, processEvent, removeActionListener, setActionCommand, setEnabled, setLabel, setShortcut`

Methods inherited from class java.awt.MenuComponent
`dispatchEvent, getFont, getName, getParent, getPeer, getTreeLock, postEvent, setFont, setName, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.awt.MenuContainer
`getFont, postEvent`

Constructor Detail

### Menu

    public Menu()

  Constructs a new menu with an empty label. This menu is not a tear-off menu.
  Since:
    JDK1.1

### Menu

    public Menu(String label)

  Constructs a new menu with the specified label. This menu is not a tear-off menu.
  Parameters:
    `label` - the menu's label in the menu bar, or in another menu of which this menu is a submenu.

### Menu

    public Menu(String label,
                boolean tearOff)

  Constructs a new menu with the specified label, indicating whether the menu can be torn off.

  Tear-off functionality may not be supported by all implementations of AWT. If a particular implementation doesn't support tear-off menus, this value is silently ignored.

  Parameters:
    `label` - the menu's label in the menu bar, or in another menu of which this menu is a submenu.
    `tearOff` - if `true`, the menu is a tear-off menu.
  Since:
    JDK1.0.

Method Detail

### addNotify

    public void addNotify()

  Creates the menu's peer. The peer allows us to modify the appearance of the menu without changing its functionality.
  Overrides:
    `addNotify` in class `MenuItem`

### removeNotify

    public void removeNotify()

  Removes the menu's peer. The peer allows us to modify the appearance of the menu without changing its functionality.
  Overrides:
    `removeNotify` in class `MenuComponent`

### isTearOff

    public boolean isTearOff()

  Indicates whether this menu is a tear-off menu.

  Tear-off functionality may not be supported by all implementations of AWT. If a particular implementation doesn't support tear-off menus, this value is silently ignored.

  Returns:
    `true` if this is a tear-off menu; `false` otherwise.

### getItemCount

    public int getItemCount()

  Get the number of items in this menu.
  Returns:
    the number of items in this menu.
  Since:
    JDK1.1

### countItems

    public int countItems()

  Deprecated. As of JDK version 1.1, replaced by `getItemCount()`.

### getItem

    public MenuItem getItem(int index)

  Gets the item located at the specified index of this menu.
  Parameters:
    `index` - the position of the item to be returned.
  Returns:
    the item located at the specified index.

### add

    public MenuItem add(MenuItem mi)

  Adds the specified menu item to this menu. If the menu item has been part of another menu, remove it from that menu.
  Parameters:
    `mi` - the menu item to be added.
  Returns:
    the menu item added.
  See Also:
    `insert(java.lang.String, int)`, `insert(java.awt.MenuItem, int)`

### add

    public void add(String label)

  Adds an item with the specified label to this menu.
  Parameters:
    `label` - the text on the item.
  See Also:
    `insert(java.lang.String, int)`, `insert(java.awt.MenuItem, int)`

### insert

    public void insert(MenuItem menuitem,
                       int index)

  Inserts a menu item into this menu at the specified position.
  Parameters:
    `menuitem` - the menu item to be inserted.
    `index` - the position at which the menu item should be inserted.
  Throws:
    `IllegalArgumentException` - if the value of `index` is less than zero.
  Since:
    JDK1.1
  See Also:
    `add(java.lang.String)`, `add(java.awt.MenuItem)`

### insert

    public void insert(String label,
                       int index)

  Inserts a menu item with the specified label into this menu at the specified position.
  Parameters:
    `label` - the text on the item.
    `index` - the position at which the menu item should be inserted.
  Since:
    JDK1.1
  See Also:
    `add(java.lang.String)`, `add(java.awt.MenuItem)`

### addSeparator

    public void addSeparator()

  Adds a separator line, or a hypen, to the menu at the current position.
  See Also:
    `insertSeparator(int)`

### insertSeparator

    public void insertSeparator(int index)

  Inserts a separator at the specified position.
  Parameters:
    `index` - the position at which the menu separator should be inserted.
  Throws:
    `IllegalArgumentException` - if the value of `index` is less than 0.
  Since:
    JDK1.1
  See Also:
    `addSeparator()`

### remove

    public void remove(int index)

  Removes the menu item at the specified index from this menu.
  Parameters:
    `index` - the position of the item to be removed.

### remove

    public void remove(MenuComponent item)

  Removes the specified menu item from this menu.
  Specified by:
    `remove` in interface `MenuContainer`
  Parameters:
    `item` - the item to be removed from the menu. If `item` is `null` or is not in this menu, this method does nothing.

### removeAll

    public void removeAll()

  Removes all items from this menu.
  Since:
    JDK1.0.

### paramString

    public String paramString()

  Gets the parameter string representing the state of this menu. This string is useful for debugging.
  Overrides:
    `paramString` in class `MenuItem`
  Since:
    JDK1.0nu.

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Gets the AccessibleContext associated with this Menu. For menus, the AccessibleContext takes the form of an AccessibleAWTMenu. A new AccessibleAWTMenu instance is created if necessary.
  Specified by:
    `getAccessibleContext` in interface `Accessible`
  Overrides:
    `getAccessibleContext` in class `MenuItem`
  Returns:
    an AccessibleAWTMenu that serves as the AccessibleContext of this Menu

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.